﻿'Copyright (C) 2013 Steven Ching
'Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:
'The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
'THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
Public Class sC
    Dim Authorized As Boolean = False
    Public Function ValidateNRIC(ByVal NRIC As String)
        Dim ValidOrInvalid As Boolean = False
        If Authorized = True Then
            Try
                NRIC = NRIC.ToUpper
                Dim SorTNRIC As Boolean = False
                Dim ForGNRIC As Boolean = False

                If NRIC.Length = 9 Then
                    If NRIC.Substring(0, 1) = "S" Then
                        SorTNRIC = True
                    ElseIf NRIC.Substring(0, 1) = "T" Then
                        SorTNRIC = True
                    ElseIf NRIC.Substring(0, 1) = "F" Then
                        ForGNRIC = True
                    ElseIf NRIC.Substring(0, 1) = "G" Then
                        ForGNRIC = True
                    End If
                    If SorTNRIC = True Then
                        'Calculation for 'S' and 'T' NRIC should be right here

                        Dim Number1 As Integer = NRIC.Substring(1, 1)
                        Dim Number2 As Integer = NRIC.Substring(2, 1)
                        Dim Number3 As Integer = NRIC.Substring(3, 1)
                        Dim Number4 As Integer = NRIC.Substring(4, 1)
                        Dim Number5 As Integer = NRIC.Substring(5, 1)
                        Dim Number6 As Integer = NRIC.Substring(6, 1)
                        Dim Number7 As Integer = NRIC.Substring(7, 1)
                        Dim LastAlphabet As String = NRIC.Substring(8, 1)
                        Dim BeforeModulus As Integer = ((Number1 * 2) + (Number2 * 7) + (Number3 * 6) + (Number4 * 5) + (Number5 * 4) + (Number6 * 3) + (Number7 * 2))

                        If NRIC.Substring(0, 1) = "T" Then
                            BeforeModulus = BeforeModulus + 4
                        End If
                        Dim AfterModulus As Integer = BeforeModulus Mod 11


                        Dim comparison As Integer = 11 - AfterModulus

                        Select Case comparison
                            Case 1
                                If LastAlphabet = "A" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 2
                                If LastAlphabet = "B" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 3
                                If LastAlphabet = "C" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 4
                                If LastAlphabet = "D" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 5
                                If LastAlphabet = "E" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 6
                                If LastAlphabet = "F" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 7
                                If LastAlphabet = "G" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 8
                                If LastAlphabet = "H" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 9
                                If LastAlphabet = "I" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 10
                                If LastAlphabet = "Z" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 11
                                If LastAlphabet = "J" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                        End Select


                    End If

                    '////////////////////////////////////////////HERE IS F AND G PREFIX////////////////////////////////////////////////////////////
                    If ForGNRIC = True Then
                        'Calculation for 'F' and 'G' NRIC should be right here

                        Dim Number1 As Integer = NRIC.Substring(1, 1)
                        Dim Number2 As Integer = NRIC.Substring(2, 1)
                        Dim Number3 As Integer = NRIC.Substring(3, 1)
                        Dim Number4 As Integer = NRIC.Substring(4, 1)
                        Dim Number5 As Integer = NRIC.Substring(5, 1)
                        Dim Number6 As Integer = NRIC.Substring(6, 1)
                        Dim Number7 As Integer = NRIC.Substring(7, 1)
                        Dim LastAlphabet As String = NRIC.Substring(8, 1)
                        Dim BeforeModulus As Integer = ((Number1 * 2) + (Number2 * 7) + (Number3 * 6) + (Number4 * 5) + (Number5 * 4) + (Number6 * 3) + (Number7 * 2))

                        If NRIC.Substring(0, 1) = "G" Then
                            BeforeModulus = BeforeModulus + 4
                        End If
                        Dim AfterModulus As Integer = BeforeModulus Mod 11


                        Dim comparison As Integer = 11 - AfterModulus

                        Select Case comparison
                            Case 1
                                If LastAlphabet = "K" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 2
                                If LastAlphabet = "L" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 3
                                If LastAlphabet = "M" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 4
                                If LastAlphabet = "N" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 5
                                If LastAlphabet = "P" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 6
                                If LastAlphabet = "Q" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 7
                                If LastAlphabet = "R" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 8
                                If LastAlphabet = "T" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 9
                                If LastAlphabet = "U" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 10
                                If LastAlphabet = "W" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                            Case 11
                                If LastAlphabet = "X" Then
                                    ValidOrInvalid = True
                                Else
                                    ValidOrInvalid = False
                                End If
                        End Select
                    End If
                End If
            Catch ex As Exception
                'MsgBox("Invalid NRIC format", MsgBoxStyle.Critical, "Error")
            End Try



        End If
        Return ValidOrInvalid
    End Function
    Public Sub AuthorizeDLL(ByVal Password As String)
        If Password = "SC" Then
            Authorized = True
        End If
    End Sub
    Public Function GenerateNRIC(ByVal Prefix As String)
        If Authorized = True Then
            Try
                If Prefix.Length = 9 Then
                    Return False
                Else
                    Dim FirstLetter As Char = Prefix.Substring(0, 1)
                    Dim ContinueFirst As Boolean = False
                    Dim LastLetter As Char = Nothing
                    Dim FirstOrSecond As Boolean = Nothing




                    If FirstLetter.ToString.ToUpper = "S" Then
                        ContinueFirst = True
                        FirstOrSecond = True

                    ElseIf FirstLetter.ToString.ToUpper = "F" Then
                        ContinueFirst = True
                        FirstOrSecond = False

                    ElseIf FirstLetter.ToString.ToUpper = "T" Then
                        ContinueFirst = True
                        FirstOrSecond = True

                    ElseIf FirstLetter.ToString.ToUpper = "G" Then
                        ContinueFirst = True
                        FirstOrSecond = False

                    End If

                    If ContinueFirst Then

                        Dim FullNRIC As String = Nothing
                        Dim Random As New Random
                        Dim GivenNumber As String = Nothing
                        If Prefix.Length <> 1 Then
                            GivenNumber = Prefix.Substring(1, Prefix.Length - 1)
                        End If
                        If GivenNumber = Nothing Then
                            For GivenLength = 1 To 7
                                GivenNumber = GivenNumber & Random.Next(0, 10)
                            Next
                        Else
                            For GivenLength = GivenNumber.ToString.Length To 6
                                GivenNumber = GivenNumber & Random.Next(0, 10)
                            Next
                        End If
                        Dim LetterComparison As Integer = (GivenNumber.ToString.Substring(0, 1) * 2) + (GivenNumber.ToString.Substring(1, 1) * 7) + (GivenNumber.ToString.Substring(2, 1) * 6) + (GivenNumber.ToString.Substring(3, 1) * 5) + (GivenNumber.ToString.Substring(4, 1) * 4) + (GivenNumber.ToString.Substring(5, 1) * 3) + (GivenNumber.ToString.Substring(6, 1) * 2)
                        If FirstLetter = "T" Then
                            LetterComparison = LetterComparison + 4
                        ElseIf FirstLetter = "G" Then
                            LetterComparison = LetterComparison + 4
                        End If
                        LetterComparison = LetterComparison Mod 11
                        If FirstOrSecond = True Then
                            If LetterComparison = 0 Then
                                LastLetter = "J"
                            ElseIf LetterComparison = 1 Then
                                LastLetter = "Z"
                            ElseIf LetterComparison = 2 Then
                                LastLetter = "I"
                            ElseIf LetterComparison = 3 Then
                                LastLetter = "H"
                            ElseIf LetterComparison = 4 Then
                                LastLetter = "G"
                            ElseIf LetterComparison = 5 Then
                                LastLetter = "F"
                            ElseIf LetterComparison = 6 Then
                                LastLetter = "E"
                            ElseIf LetterComparison = 7 Then
                                LastLetter = "D"
                            ElseIf LetterComparison = 8 Then
                                LastLetter = "C"
                            ElseIf LetterComparison = 9 Then
                                LastLetter = "B"
                            ElseIf LetterComparison = 10 Then
                                LastLetter = "A"
                            End If
                        Else
                            If LetterComparison = 0 Then
                                LastLetter = "X"
                            ElseIf LetterComparison = 1 Then
                                LastLetter = "W"
                            ElseIf LetterComparison = 2 Then
                                LastLetter = "U"
                            ElseIf LetterComparison = 3 Then
                                LastLetter = "T"
                            ElseIf LetterComparison = 4 Then
                                LastLetter = "R"
                            ElseIf LetterComparison = 5 Then
                                LastLetter = "Q"
                            ElseIf LetterComparison = 6 Then
                                LastLetter = "P"
                            ElseIf LetterComparison = 7 Then
                                LastLetter = "N"
                            ElseIf LetterComparison = 8 Then
                                LastLetter = "M"
                            ElseIf LetterComparison = 9 Then
                                LastLetter = "L"
                            ElseIf LetterComparison = 10 Then
                                LastLetter = "K"
                            End If
                        End If
                        FullNRIC = FirstLetter & GivenNumber & LastLetter
                        FullNRIC = FullNRIC.ToUpper
                        Return FullNRIC
                    End If
                End If

            Catch ex As Exception

            End Try
        End If
        Return False

    End Function
End Class
